<?php	// TWIG		Module Framework Processor ?>
<?php

 Function getmicrotime()
	{
 	$mtime = microtime();
 	$mtime = explode( " ", $mtime );
 	$mtime = $mtime[1] + $mtime[0];
 	return( $mtime );
	}

 $ts1 = getmicrotime();

 $version = "2.6.2";
 $config = array();
 $dbconfig = array();
 $vhosts = array();
 $img = array();

 // Load the config options
 require( "config/config.inc.php3" );	// Global Configuration Variables

 // Load the image source files
 require( "config/images.inc.php3" );

 // Load the database config file
 require("config/dbconfig.inc.php3");

 // Allow for virtual hosting
 $config_dir = "config";
 if( $vhosts[$SERVER_NAME] ) 
	{ 
   	$config_dir = $vhosts[$SERVER_NAME]; 
   	include( $config_dir . "/config.inc.php3" );
   	include( $config_dir . "/dbconfig.inc.php3" );
   	include( $config_dir . "/images.inc.php3" );
 	}

 // Set up database
 if( !$dbconfig["sqltype"] ) { $dbconfig["sqltype"] = "mysql"; }
 require( "lib/db/" . $dbconfig["sqltype"] . ".db.inc.php3" );

 if( !$config["imap_servertype"] ) { $config["imap_servertype"] = "php-imap"; }
 require( "lib/mail/" . $config["imap_servertype"] . ".inc.php3" );	// include the mail subsystem

 require( "lib/auth/" . $config["auth"] . ".inc.php3" );		// include the auth system...
 require( "lib/session/" . $config["session_handler"] . ".session.php3" );	// include the session data handler...
 require( "lib/login/" . $config["login_handler"] . ".login.php3" );	// include the login data handler...
 require( "features/common.inc.php3" );					// include common functions...
 require( "lib/security/" . $config["security"] . ".inc.php3" );	// include security system...

 // Set default URL paths
 $config["baseurl"] = $config["basedir"] . "/" . $config["index"];

 // Set default IMAP parameters
 if( !$config["imap_server"] ) { $config["imap_server"] = "localhost"; }
 if( !$config["imap_port"] ) { $config["imap_port"] = "143"; } 

 // Tell browsers not to cache us.  The if is a hack to get around a problem in IE, I hate this hack but see no other way
 if( !$attachment )
	{
	Header( "Cache-Control: no-cache" );
	Header( "Pragma: no-cache" );
	Header( "Expires: Tue, Jan 12 1999 01:01:01 GMT" );
	}

 $context = TWIGGetContext(); 
 $session = TWIGGetSession();
 $login = TWIGGetLogin();

 if( $GoToFeature ) { TWIGGoToFeature( $GoToFeature ); parse_str( $context["options"] ); }
 if( $newmailbox ) { $session["mailbox"] = $newmailbox; }

 $mbox = TWIGAuth( "TWIG", $logout );

 // Get the default preferences and load the prefs code.
 require( "config/defaults.inc.php3" );
 if( $vhosts[$SERVER_NAME] ) { include( $config_dir . "/defaults.inc.php3" ); }
 require( "features/shared/prefs.inc.php3" );

 // language code - turn into function to load feature/language.string.php3
 $config["language"] = GetPref( "language", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["language"] );
 
 // The order here is reversed from what you should expect.
 // You *might* think that the specific feature's language should override the global file.
 // But, in order to allow a gradual implementation of the distributed language files,
 // we let the global file override the specific file so that we don't get English
 // for languages that haven't been updated to the new layout.
 TWIGLoadLanguageFile( "features/" . $context["feature"] . "/strings/", "", $config["language"] );
 TWIGLoadLanguageFile( "lib/strings/", "", $config["language"] );

 require( "features/" . $context["feature"] . "/" . $context["feature"] . ".inc.php3" );

 $sorted[0] = 1;

 // Set group info
 if( !$config["groups"] ) { $config["groups"] = "standard"; }
 require( "lib/groups/" . $config["groups"] . ".groups.inc.php3" );
?>

<html><?php if( $config["metaheaders"] ) { echo $config["metaheaders"]; }
?>
<head>
<title><?php echo $pagetitle;?></title>
</head>

<?php
 require( $config_dir . "/header.inc.php3" );
 if( !$TWIGNoHeader ) { include( "features/twig.header.inc.php3" ); }
 flush();
 require( "features/" . $context["feature"] . "/" . $context["feature"] . ".feature.php3" );
 flush();
 if( !$TWIGNoFooter ) { include( "features/twig.footer.inc.php3" ); }
 require( $config_dir . "/footer.inc.php3" );

 TWIGCloseMB( $mbox );
 TWIGDebug( "Page output time - " . ( getmicrotime() - $ts1 ) );
?>
</html>
